# Module ring::aead [−] [src]

Authenticated Encryption with Associated Data (AEAD).

See Authenticated encryption: relations among notions and analysis of the generic composition paradigm for an introduction to the concept of AEADs.

C analog: `GFp/aead.h`

Go analog: `crypto.cipher.AEAD`

## Modules

chacha20_poly1305_openssh | The chacha20-poly1305@openssh.com AEAD-ish construct.

## Structs

Algorithm | An AEAD Algorithm.
OpeningKey | A key for authenticating and decrypting (“opening”) AEAD-protected data.
SealingKey | A key for encrypting and signing (“sealing”) data.

## Constants

MAX_TAG_LEN | The maximum length of a tag for the algorithms in this module.

## Statics

AES_128_GCM | AES-128 in GCM mode with 128-bit tags and 96 bit nonces.
AES_256_GCM | AES-256 in GCM mode with 128-bit tags and 96 bit nonces.
CHACHA20_POLY1305 | ChaCha20-Poly1305 as described in RFC 7539.

## Functions

open_in_place | Authenticates and decrypts (“opens”) data in place. When
seal_in_place | Encrypts and signs (“seals”) data in place.

# Help

## Keyboard Shortcuts

?
  Show this help dialog
S
  Focus the search field
⇤
  Move up in search results
⇥
  Move down in search results
⏎
  Go to active search result
+
  Collapse/expand all sections

## Search Tricks

Prefix searches with a type followed by a colon (e.g. `fn:`) to restrict the search to a given type.

Accepted types are: `fn`, `mod`, `struct`, `enum`, `trait`, `type`, `macro`, and `const`.

Search functions by type signature (e.g. `vec -> usize` or `* -> vec`)